//
//  Heap.h
//  Heap
//
//  Created by Grassi, Dan on 8/20/12.
//  Copyright (c) 2012 Zaph, llc. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface HeapItem : NSObject
@property (assign, readonly, nonatomic) int       itemID;
@property (strong, nonatomic)           NSString *text;
@property (assign, nonatomic)           int       value;

+ (id)heapItemWithValue:(int)value;
@end


@interface Heap : NSObject <NSFastEnumeration>
@property (assign, readonly, nonatomic) NSUInteger     count;
@property (assign, nonatomic)           NSTimeInterval delay;
@property (assign, readonly, nonatomic) int            nextItemID;

- (HeapItem *)insertItemWithValue:(int)value;
- (HeapItem *)peekItem;
- (HeapItem *)deleteItem;

- (HeapItem *)topObject;
- (HeapItem *)lastObject;
- (HeapItem *)parentForChild:(HeapItem *)child;
- (HeapItem *)leftChildForParent:(HeapItem *)parent;
- (HeapItem *)rightChildForParent:(HeapItem *)parent;

- (NSString *)descriptionByValue;
- (NSAttributedString *)attributedDescriptionByValue;

@end
