//
//  ViewController.m
//  Tree
//
//  Created by Grassi, Dan on 8/14/12.
//  Copyright (c) 2012 Zaph, llc. All rights reserved.
//

#import "ViewController.h"
#import "TreeView.h"
#import "Node.h"
#import "TreeDataModel.h"

@interface ViewController ()
@property (weak, nonatomic) IBOutlet TreeView *treeView;
@end

@implementation ViewController {
    TreeDataModel *_treeDataModel;
}

- (void)viewDidLoad {
    [super viewDidLoad];

    _treeDataModel = [TreeDataModel new];
}

- (void)viewDidAppear:(BOOL)animated {
    _treeDataModel.topNode = [self createTestGraphNode];
//    self.treeView.highlightList = @[@5];
    
//    Node *foundNode = [_treeDataModel findNodeID:13];
//    zlog(@"foundNode: %@", foundNode);

//    [_treeDataModel updateLevels];
//    [_treeDataModel reportLevelsforNode:topNode];
    
    self.treeView.vertexSize = 10;
    self.treeView.lineWidth  = 1.5;
    self.treeView.fontSize   = 12;
    self.treeView.treeDataModel = _treeDataModel;

    [self refresh];
}

- (void)refresh {
    [_treeDataModel updateLevels];
    [self.treeView setNeedsDisplay];
}

- (Node *)createTestGraphNode {
    Node *base = [Node nodeWithText:@"Top"];

    [base addChild:[Node new]];

    Node *node1 = [Node nodeWithText:@""];
    [base addChild:node1];
    Node *node2 = [Node new];
    [base addChild:node2];

    [node1 addChild:[Node new]];
    [node1 addChild:[Node new]];

    [node2 addChild:[Node new]];
    Node *node3 = [Node new];
    [node2 addChild:node3];
    [node2 addChild:[Node new]];
    [node2 addChild:[Node new]];

    [node3 addChild:[Node new]];
    [node3 addChild:[Node new]];
    Node *node4 = [Node new];
    [node3 addChild:node4];
    
    [node4 addChild:[Node new]];
    [node4 addChild:[Node new]];

    return base;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

@end
